;fm2.orc
	sr	=	44100
	kr	=	4410
	ksmps	=	10
	nchnls	=	1

	instr	1

; 1st MODULATOR
imfrq	=	p4	;modulating freq
indmax	=	p5	;max index value
indxatk	= 	p6	;rise time for the index envelope		
indxperc =	p7	;percentage of indmax for decay (in decimals:
			;0.80=80%). When indmax = 100, the modulation 
			;index will go from 0 to 100 over indxatk seconds, then if indxperc = 0.80, 
			;it decays to 80. When indxperc=1 there's no decay, and the index value 
			;remains unchanged. Were indxperc=1.2, there would be a further increase in 
			;the index, up to 120. This second portion of the envelope (be it decay, 
			;sustain or further increase) takes place in p3-indxatk-indxrel seconds, i.e. 
			;in a time equal to the note duration minus attack time and release time. In 
			; the last envelope portion, the index goes down to 0 in indxrel seconds (we 
			;write 0.001 instead of 0 because the envelope is generated with expseg, see 
			;chap.1).

indxrel	=	p8	;release time

;1st modulator index envelope
kindxenv expseg .001,indxatk,indmax,p3-indxatk, indxrel,indmax*indxperc,indxrel,.001

;2nd MODULATOR
imfrq2		=	p9	;modulating freq
indmax2		=	p10	;max index value
indxatk2	= 	p11	;rise time for index envelope 		
indxperc2	=	p12	;percentage of indmax2 for decay (see above)
indxrel2	=	p13	;release time

;2nd modulator index envelope
kindxenv2 	expseg .001,indxatk2,indmax2,p3-indxatk2-indxrel2,indmax2 * \ indxperc2,indxrel2,.001

;CARRIER 
icamp	 	=	p14	;carrier amp (0-32768)
icfrq	 	=	p15	;carrier freq(Hz)
iatk		=	p16	;rise time 
iperc		=	p17	;percentage of icamp for decay
irel		=	p18	;release time

;carrier amplitude envelope 
kenvc		expseg	 .001,iatk, icamp, p3-iatk-irel,icamp * iperc,irel,.001

amod1		oscili	kindxenv*imfrq,imfrq,1		;1st modulator
amod2		oscili	kindxenv2*imfrq2,imfrq2,1	;2nd modulator
acar		oscili	kenvc,icfrq+amod1+amod2,1	;carrier
	
out		acar
		endin
 
