;phmod4.orc
	sr = 44100
	kr = 44100	;NOTICE sr=kr!
	ksmps = 1
	nchnls = 1
	instr	1

adelay1	init	0	; initializes the adelay1 variable
a3	init	0	; and the a3 variable

ifrq	=	cpspch(p5) 	; pitch to Hz conversion
idelay1	=	1/ifrq		; set the delay of the 1st delay line
iamp	=	ampdb(p4)*10
iatk	=	p6		; duration of the attack transient 
ifeed	=	p7		; feedback factor
imaxemb	=	p8		; max value for the embouchure
icutoff	=	p9		; cutoff freq for low-pass filter

kembofs linseg 	0,.1,imaxemb,p3-.1,0 ; pressure applied against embouchure
amouthp linseg 	0,iatk,1,p3-iatk,1,.001,0 ; air flow pressure
avibr	oscil	.05,5,1	; oscillator for vibrato
amouthp	=	amouthp+avibr
a1	=	amouthp - a3 * ifeed
adelay1	delay	a1,idelay1
ahp1	atone	adelay1,50	; four high-pass filters ...
ahp2	atone	ahp1,50	; ...in series ...
ahp3	atone	ahp2,50	; ...equivalent to a 4th order ...
ahp	atone	ahp3,50	; ...high-pass
afilt	tone	adelay1,icutoff	; signal after reflection energy loss
adelay2	delay	afilt,idelay1
a2	=	adelay2 + amouthp + kembofs
k2	downsamp a2 ; abs value converter works only at krate!
			         ; downsamp opcode discussed in section 17.2
ktab	table	abs(k2),99,2
a3	=	a2 * ktab	
kenv	linseg	1,p3-.1,1,.1,0
aout	=	ahp*iamp*kenv
	out	aout
	endin

