;scale.orc
	sr = 22050
	kr = 2205
	ksmps = 10
	nchnls = 1

	instr	1

;first separate the integer part (octaves) from the fractional part 
;(semitones) of p5 

ioct	=	int(p5)	;octaves 
isem	=	frac(p5)*100	;semitones, multiplied by 100 (hence 8.01 yields 1, 				;8.11 yields 11 etc). These numbers are used, then, 				;as index to function table n.2, returning new 				;pitch values: each tempered pitch is 						;replaced by some non-tempered pitch stored in the 				;table

isem1		table	isem,2,0	;takes a value from function table 2, at the
					;position specified by isem
					;(3rd argument = 0, i.e no index scaling: 					;therefore, isem=0 takes the first value, 					;isem =1 takes the second, isem =3 the 					;fourth, etc.) 

ifrq	=	cpspch(ioct+isem1) 	;convert octave+chroma to Hertz
iamp	=	ampdb(p4)
a1	oscili	iamp, ifrq, 1
	out	a1
	endin

	instr	2

;use table to build a non-equally tempered tuning system, with interpolation

ioct	=	int(p5)		;octave 
isem	=	frac(p5)*100		;semitone, multiplied by 100 
					 
isem1	tablei	isem, 2, 0		;same as instr 1, but interpolated table 					;read, isem1 can be fractional.
ifrq	=	cpspch(ioct+isem1) 	;convert octave+chroma to Hertz
iamp	=	ampdb(p4)		;convert dB values to absolute amplitude
a1	oscil	iamp, ifrq, 1
	out	a1
	endin

