sr    	=	44100
kr    	=	147
ksmps  	=	300
nchnls  =	2

garev1	init	0
gaout1	init	0
gaout2	init	0

;-------

;///////////////////////////////////////
	instr	100
;///////////////////////////////////////

gk_1,gk_2,gk_3,gk_4,gk_5,gk_6,gk_7,gk_8,\
gk_9,gk_10,gk_11,gk_12,gk_13,gk_14,gk_15,gk_16	slider16	1,\
\;	ctl	min	max	init	func
	1,	1,	1,	1,	0,	\;1 audio table num
	2,	0,	13.5,	1,	0,	\;2 playback rate
	3,	.5,	5,	3,	0,	\;3 grain repeat rate
	4,	0,	2,	1,	0,	\;4 speed of phase changing
	5,	0,	1,	0,	0,	\;5 end pitch of glissandos
	6,	.005,	4,	.5,	100,	\;6 total grain duration
	7,	1/15,	1,	.3,	0,	\;7 grain attack duration
	8,	1/15,	1,	.3,	0,	\;8 grain decay duration
	9,	0,	.12,	0,	0,	\;9 reverb send
	10,	300,	8000,	3200,	0,	\;10 reverb lowpass filter
	11,	0,	2,	0,	0,	\;11 grain random pitch percent
	12,	0,	3,	0,	0,	\;12 grain random duration percent
	13,	0,	.2,	.05,	0,	\;13 left/right channel phase difference
	14,	0,	.5,	0,	0,	\;14 grain random phase percent
	15,	0,	3,	0,	0,	\;15 octaviation factor
	16,	.05,	2,	1,	0	;16 overall volume


gk_17,gk_18,gk_19,gk_20,gk_21,gk_22,gk_23,gk_24	slider8  1,\
\;	ctl	min	max	init	func
	17,	102,	105.5,	102,	0,	\;17 random harmonic table num
	18,	0,	8.5,	0,	0,	\;18 random harmonic amount  (table index)
	19,	1,	1.5,	1,	0,	\;19 repeat rate left-right deviation factor
	20,	0,	1,	0,	0,	\;20 phase offset
	21,	0,	15,	0,	0,	\;21 grain random tempo
	22,	0,	1,	0,	0,	\
	23,	0,	1,	0,	0,	\
	24,	0,	1,	0,	0

;************ REVERB and OUTPUT *************
arevb	tonex	garev1, gk_10,3
arev	reverb2	arevb, 9, .05
	outs	gaout1 + arev, gaout2 + arev
	clear	gaout1,gaout2,garev1
	endin



;//////////////////////////////////////////
	instr 	1
;//////////////////////////////////////////
ifmidi	cpsmidi	
;ifmidi	=	ifmidi/127*.98 ;***** raw pitch
iamp	ampmidi	1

ifna	=	int(i(gk_1))	;** ifna, input sound file through gen 01
ifna2 	=	ifna		;** right channel table num (in this case is the same of ifna)
imemlen	=	ftlen(ifna)	;** allocated table length
ilen	=	nsamp(ifna)	;** number of samples
ilnDmem	=	ilen/imemlen 	;** sample_length down table_length
ifsr	=	ftsr(ifna)/sr	;** sample rate of table down sr
isrDmem	=	sr/imemlen	;** to compute the normal frequency
isrDdur	=	ftsr(ifna)/ilen	;** sampling rate of sound table down number of samples


krdharm	linrand	gk_18		;**  random harmonic amount 
krdharm2	linrand	gk_18		;**  random harmonic amount 
krdharm	table	krdharm, i(gk_17)
krdharm2	table	krdharm2, i(gk_17)  
kform	table	gk_2, 151
kform	=	(ifmidi/127*.98)*kform*isrDmem*ifsr
krndpch	trirand	gk_11		;**  random amount of pitch
krndpch2	trirand	gk_11
kform1  	=	kform*powoftwo(krndpch)*krdharm   ;**  left channel grain pitch 
kform2	=	kform*powoftwo(krndpch2)*krdharm2 ;** right channel grain pitch
krnd	trirand	gk_21
kfund 	= 	2^(gk_3+krnd) ;** repeat rate

kphsrate	=	gk_4*isrDdur

krndphs	linrand	gk_14	;** random phase percent

kphs	init	0
kphs	phasor	kphsrate
kphs	=	(kphs+krndphs+gk_20) * ilnDmem
kphs	wrap	kphs,0,ilnDmem

kphs2	init	0
kphs2	phasor	kphsrate,i(gk_13); ** phase of right channel can be shifted for stereo effects
kphs2	=	(kphs2+krndphs+gk_20)* ilnDmem
kphs2	wrap	kphs2,0,ilnDmem

kgliss	=	gk_5			;** Grain glissandi
krnddur	linrand	gk_12		     ;** random amount of grain duration
kdur	=	(1+krnddur) * gk_6 		;** (Can go up to 3.5 / kfund, but watch amp)
kris	=	kdur * gk_7
kdec	=	kdur * gk_8
iolaps	=	100

kampenv	linenr	iamp*gk_16, 0,.1,.03

;** 		        xfund          koct      kris        kdec          ifna      itotdur      kgliss
;** 		xamp            xform      kband      kdur        iolaps        ifnb        kphs 
;**		----------------------------------------------------------------------------------------
a1	fof3	kampenv,kfund,  kform1, gk_15, 0, kris, kdur, kdec, iolaps, ifna, 101, 3600, kphs, kgliss
a2	fof3	kampenv,kfund*gk_19,kform2,gk_15,0,kris,kdur, kdec, iolaps, ifna2,101, 3600, kphs2,kgliss

	vincr	gaout1, a1 * (1 - gk_9)	;** main out left
	vincr	gaout2, a2 * (1 - gk_9)	;** main out right
	vincr	garev1, (a1 + a2) * gk_9	;** reverb send
	endin

